import Foundation

extension Array {
    
    func rotated(toStartAt index: Int) -> [Element] {
        guard index != 0 else {
            return self
        }
        return Array(self[index..<count] + self[0..<index])
    }

    func sorted<T>(by converting: (Element) -> T) -> [Element] where T: Comparable {
        sorted { converting($0) < converting($1) }
    }
}
